/*!
 * XMG365
*/

Ext.override(Ext.calendar.CalendarView, {
	getEventRecord: function(id) {
	  var idx = this.store.findBy(function(rec, recId){return(rec.get(Ext.calendar.EventMappings.EventId.name)==id)});
	  return this.store.getAt(idx);
	}
});

Ext.override(Ext.calendar.CalendarPanel, {

	setItemDate: function(item) {
		var bb=null, dd=null;

		if (this.stDate)
			dd=this.stDate;
		else if (this.startDate)
			dd=this.startDate;

		if (dd) {
			aa=dd.format('dmy');

			if (item.stDate)
				bb=item.stDate.format('dmy');

			if (aa!=bb) {
				item.stDate=dd;
				item.setStartDate(dd, true);
			}
		}
	},

	onDayClick: Ext.calendar.CalendarPanel.prototype.onDayClick.createSequence(function() {
		this.setItemDate(this.layout.activeItem);
	}),

	onWeekClick: Ext.calendar.CalendarPanel.prototype.onWeekClick.createSequence(function() {
		this.setItemDate(this.layout.activeItem);
	}),

	onMonthClick: Ext.calendar.CalendarPanel.prototype.onMonthClick.createSequence(function() {
		this.setItemDate(this.layout.activeItem);
	}),

  onPrevClick: Ext.calendar.CalendarPanel.prototype.onPrevClick.createSequence(function() {
  	var a=this.layout.activeItem;
  	if (a) {
	  	if (a.startDate)
				this.stDate = a.startDate;
			else if (a.body)
				this.stDate = a.body.startDate;
		}
  }),

  onNextClick: Ext.calendar.CalendarPanel.prototype.onNextClick.createSequence(function() {
  	var a=this.layout.activeItem;
  	if (a) {
	  	if (a.startDate)
				this.stDate = a.startDate;
			else if (a.body)
				this.stDate = a.body.startDate;
		}
  }),

	setStartDate: Ext.calendar.CalendarPanel.prototype.setStartDate.createSequence(function(dt) {
		this.stDate = dt;
		this.layout.activeItem.stDate = dt;
	})
});
